Index: trunk/ab5.0/ablib/TestCase/SimpleTestCase/CollectionTest.ab
===================================================================
--- trunk/ab5.0/ablib/TestCase/SimpleTestCase/CollectionTest.ab	(revision 653)
+++ trunk/ab5.0/ablib/TestCase/SimpleTestCase/CollectionTest.ab	(revision 656)
@@ -9,8 +9,8 @@
 	d.Add("茶", "Tea")
 
-	UnitTest("Dictionary.Add, Item (1)", d.Item["赤"] = "Red")
-	UnitTest("Dictionary.Add, Item (2)", d.Item["黄"] = "Yellow")
-	UnitTest("Dictionary.Add, Item (3)", d.Item("緑") = "Green")
-	UnitTest("Dictionary.Add, Item (4)", d.Item("青") = "Blue")
+	UnitTest("Dictionary.Add, Item (1)", d.Item["赤"], "Red")
+	UnitTest("Dictionary.Add, Item (2)", d.Item["黄"], "Yellow")
+	UnitTest("Dictionary.Add, Item (3)", d.Item("緑"), "Green")
+	UnitTest("Dictionary.Add, Item (4)", d.Item("青"), "Blue")
 
 	UnitTest("Dictionary.Remove", d.Remove("茶"))
Index: trunk/ab5.0/ablib/TestCase/SimpleTestCase/DelegateTest.ab
===================================================================
--- trunk/ab5.0/ablib/TestCase/SimpleTestCase/DelegateTest.ab	(revision 653)
+++ trunk/ab5.0/ablib/TestCase/SimpleTestCase/DelegateTest.ab	(revision 656)
@@ -5,5 +5,5 @@
 Public
 	Sub StringEx( str As String )
-		String( str )
+		String( StrPtr(str), str.Length )
 	End Sub
 End Class
@@ -119,5 +119,5 @@
 
 	Dim dg7 = New Callback7( AddressOf(TestClass.Proc7) )	' 共変戻り値サポートのテスト
-	UnitTest( "Delegate2", dg7( "test value" ) = "Proc7 result[test value]" )
+	UnitTest( "Delegate2", dg7( "test value" ), "Proc7 result[test value]" )
 
 	Dim dg184 = New CallbackTicket184( AddressOf( testObj.Ticket184 ) )
Index: trunk/ab5.0/ablib/TestCase/SimpleTestCase/GCHandleTest.ab
===================================================================
--- trunk/ab5.0/ablib/TestCase/SimpleTestCase/GCHandleTest.ab	(revision 653)
+++ trunk/ab5.0/ablib/TestCase/SimpleTestCase/GCHandleTest.ab	(revision 656)
@@ -21,3 +21,3 @@
 End Namespace
 
-GCHandleTest.TestMain()
+'GCHandleTest.TestMain()
Index: trunk/ab5.0/ablib/TestCase/SimpleTestCase/Generics.ab
===================================================================
--- trunk/ab5.0/ablib/TestCase/SimpleTestCase/Generics.ab	(revision 653)
+++ trunk/ab5.0/ablib/TestCase/SimpleTestCase/Generics.ab	(revision 656)
@@ -31,5 +31,5 @@
 	' TODO: より多くのパターンで試す必要あり
 	Dim bar = New Bar<Long>
-	UnitTest( "Generic ... complex", bar.GetTypeName( New String() ) = "String" )
+	UnitTest( "Generic ... complex", bar.GetTypeName( New String() ), "String" )
 End Sub
 
Index: trunk/ab5.0/ablib/TestCase/SimpleTestCase/ObjectTest.ab
===================================================================
--- trunk/ab5.0/ablib/TestCase/SimpleTestCase/ObjectTest.ab	(revision 653)
+++ trunk/ab5.0/ablib/TestCase/SimpleTestCase/ObjectTest.ab	(revision 656)
@@ -18,10 +18,10 @@
 	UnitTest( "Object.GetHashCode", obj1.GetHashCode() = ObjPtr( obj1 ) )
 
-	UnitTest( "Object.ToString", obj1.ToString() = "Object" )
+	UnitTest( "Object.ToString", obj1.ToString(), "Object" )
 
-	UnitTest( "Object.GetType", obj1.GetType().Name = "Object" )
+	UnitTest( "Object.GetType", obj1.GetType().Name, "Object" )
 End Sub
 
 End Namespace
 
-ObjectTest.TestMain()
+'ObjectTest.TestMain()
Index: trunk/ab5.0/ablib/TestCase/SimpleTestCase/PathTest.ab
===================================================================
--- trunk/ab5.0/ablib/TestCase/SimpleTestCase/PathTest.ab	(revision 653)
+++ trunk/ab5.0/ablib/TestCase/SimpleTestCase/PathTest.ab	(revision 656)
@@ -9,23 +9,23 @@
 Sub TestMain()
 	Dim testPath = New String("C:\Dir.Name\file.name.ext")
-	UnitTest("Path.GetFileName", Path.GetFileName(testPath) = "file.name.ext")
+	UnitTest("Path.GetFileName", Path.GetFileName(testPath), "file.name.ext")
 
-	UnitTest("Path.GetFileNameWithoutExtension", Path.GetFileNameWithoutExtension(testPath) = "file.name")
+	UnitTest("Path.GetFileNameWithoutExtension", Path.GetFileNameWithoutExtension(testPath), "file.name")
 
 
-	UnitTest("Path.GetExtension", Path.GetExtension(testPath) = ".ext")
+	UnitTest("Path.GetExtension", Path.GetExtension(testPath), ".ext")
 
-	UnitTest("Path.ChangeExtension", Path.ChangeExtension(testPath, ".newExt") = "C:\Dir.Name\file.name.newExt")
+	UnitTest("Path.ChangeExtension", Path.ChangeExtension(testPath, ".newExt"), "C:\Dir.Name\file.name.newExt")
 
 	UnitTest("Path.HasExtension (Case1)", Path.HasExtension(testPath) = True)
 	UnitTest("Path.HasExtension (Case2)", Path.HasExtension("fileName") = False)
 
-	UnitTest("Path.GetPathRoot", Path.GetPathRoot(testPath) = "C:\")
+	UnitTest("Path.GetPathRoot", Path.GetPathRoot(testPath), "C:\")
 
 	UnitTest("Path.IsPathRooted (Case1)", Path.IsPathRooted(testPath) = True)
 	UnitTest("Path.IsPathRooted (Case2)", Path.IsPathRooted("Dir.Name\file.name.ext") = False)
 
-	UnitTest("Path.Combine (Case1)", Path.Combine("C:\dir", "filename.txt") = "C:\dir\filename.txt")
-	UnitTest("Path.Combine (Case2)", Path.Combine("C:\dir\", "filename.txt") = "C:\dir\filename.txt")
+	UnitTest("Path.Combine (Case1)", Path.Combine("C:\dir", "filename.txt"), "C:\dir\filename.txt")
+	UnitTest("Path.Combine (Case2)", Path.Combine("C:\dir\", "filename.txt"), "C:\dir\filename.txt")
 
 /*
Index: trunk/ab5.0/ablib/TestCase/SimpleTestCase/SimpleTestCase.ab
===================================================================
--- trunk/ab5.0/ablib/TestCase/SimpleTestCase/SimpleTestCase.ab	(revision 653)
+++ trunk/ab5.0/ablib/TestCase/SimpleTestCase/SimpleTestCase.ab	(revision 656)
@@ -25,7 +25,4 @@
 
 'Initialize()
-
-Dim prevBackColor = System.Console.BackgroundColor
-Dim prevForeColor = System.Console.ForegroundColor
 
 #include "SimpleTestCase.idx"
Index: trunk/ab5.0/ablib/TestCase/SimpleTestCase/StreamTest.ab
===================================================================
--- trunk/ab5.0/ablib/TestCase/SimpleTestCase/StreamTest.ab	(revision 653)
+++ trunk/ab5.0/ablib/TestCase/SimpleTestCase/StreamTest.ab	(revision 656)
@@ -13,8 +13,8 @@
 	UnitTest("sr.Read() - 2", sr.Read() = &h20)
 	UnitTest("sr.Peek()", sr.Peek() = &h61)
-	UnitTest("sr.ReadLine() \n", sr.ReadLine() = "abc")
-	UnitTest("sr.ReadLine() \r\n", sr.ReadLine() = "123")
+	UnitTest("sr.ReadLine() \n", sr.ReadLine(), "abc")
+	UnitTest("sr.ReadLine() \r\n", sr.ReadLine(), "123")
 	Dim s = sr.ReadToEnd()
-	UnitTest("sr.ReadToEnd() \r\n", s = Ex"あいうえお\r\nアイウエオ")
+	UnitTest("sr.ReadToEnd() \r\n", s, Ex"あいうえお\r\nアイウエオ")
 End Sub
 
Index: trunk/ab5.0/ablib/TestCase/SimpleTestCase/StringBuilderTest.ab
===================================================================
--- trunk/ab5.0/ablib/TestCase/SimpleTestCase/StringBuilderTest.ab	(revision 653)
+++ trunk/ab5.0/ablib/TestCase/SimpleTestCase/StringBuilderTest.ab	(revision 656)
@@ -9,16 +9,16 @@
 Sub TestMain()
 	Dim sb = New StringBuilder("Hello")
-	UnitTest("StringBuilder - Constractor & ToString", sb.ToString, "Hello")
+	UnitTest("StringBuilder - Constractor & ToString", sb.ToString(), "Hello")
 	UnitTest("StringBuilder.ToString(index, count)", sb.ToString(1, 3), "ell")
-	UnitTest("StringBuilder.Append", sb.Append("StringBuilder").ToString, "HelloStringBuilder")
-	UnitTest("StringBuilder.Insert (String)", sb.Insert(5, ", ").ToString, "Hello, StringBuilder")
+	UnitTest("StringBuilder.Append", sb.Append("StringBuilder").ToString(), "HelloStringBuilder")
+	UnitTest("StringBuilder.Insert (String)", sb.Insert(5, ", ").ToString(), "Hello, StringBuilder")
 	sb.Length = 0
-	UnitTest("StringBuilder.Length = 0", sb.ToString, "")
+	UnitTest("StringBuilder.Length = 0", sb.ToString(), "")
 	sb.Append("でてこいでてこいいけのこい")
 	sb.Replace("こい", "いけ").Replace("いけ", "こい")
-	UnitTest("StringBuilder.Replace (String)", sb.ToString, "でてこいでてこいこいのこい")
+	UnitTest("StringBuilder.Replace (String)", sb.ToString(), "でてこいでてこいこいのこい")
 	sb.Length = 0
 	sb.Append(123)
-	UnitTest("StringBuilder.Append (Long)", sb.ToString, "123")
+	UnitTest("StringBuilder.Append (Long)", sb.ToString(), "123")
 End Sub
 
Index: trunk/ab5.0/ablib/TestCase/SimpleTestCase/VersionTest.ab
===================================================================
--- trunk/ab5.0/ablib/TestCase/SimpleTestCase/VersionTest.ab	(revision 653)
+++ trunk/ab5.0/ablib/TestCase/SimpleTestCase/VersionTest.ab	(revision 656)
@@ -10,13 +10,13 @@
 	Dim v1234 = New System.Version(1, 2, 3, 4)
 
-	UnitTest("Version(major, minor)", String.Compare(v12.ToString(), "1.2") = 0)
-	UnitTest("Version(major, minor, build)", String.Compare(v123.ToString(), "1.2.3") = 0)
-	UnitTest("Version(major, minor, build, revision)", String.Compare(v1234.ToString(), "1.2.3.4") = 0)
+	UnitTest("Version(major, minor)", v12.ToString(), "1.2")
+	UnitTest("Version(major, minor, build)", v123.ToString(), "1.2.3")
+	UnitTest("Version(major, minor, build, revision)", v1234.ToString(), "1.2.3.4")
 
-	UnitTest("Version.ToString(0)", String.Compare(v1234.ToString(0), "") = 0)
-	UnitTest("Version.ToString(1)", String.Compare(v1234.ToString(1), "1") = 0)
-	UnitTest("Version.ToString(2)", String.Compare(v1234.ToString(2), "1.2") = 0)
-	UnitTest("Version.ToString(3)", String.Compare(v1234.ToString(3), "1.2.3") = 0)
-	UnitTest("Version.ToString(4)", String.Compare(v1234.ToString(4), "1.2.3.4") = 0)
+	UnitTest("Version.ToString(0)", v1234.ToString(0), "")
+	UnitTest("Version.ToString(1)", v1234.ToString(1), "1")
+	UnitTest("Version.ToString(2)", v1234.ToString(2), "1.2")
+	UnitTest("Version.ToString(3)", v1234.ToString(3), "1.2.3")
+	UnitTest("Version.ToString(4)", v1234.ToString(4), "1.2.3.4")
 
 	UnitTest("Version.Major", v1234.Major = 1)