Index: trunk/ab5.0/abdev/abdev/abdev.rc
===================================================================
--- trunk/ab5.0/abdev/abdev/abdev.rc	(revision 481)
+++ trunk/ab5.0/abdev/abdev/abdev.rc	(revision 660)
@@ -1,3 +1,3 @@
-// Microsoft Visual C++ generated resource script.
+//Microsoft Developer Studio generated resource script.
 //
 #include "resource.h"
@@ -28,10 +28,10 @@
 //
 
-1 TEXTINCLUDE 
+1 TEXTINCLUDE MOVEABLE PURE 
 BEGIN
     "resource.h\0"
 END
 
-2 TEXTINCLUDE 
+2 TEXTINCLUDE MOVEABLE PURE 
 BEGIN
     "#include ""afxres.h""\r\n"
@@ -39,5 +39,5 @@
 END
 
-3 TEXTINCLUDE 
+3 TEXTINCLUDE MOVEABLE PURE 
 BEGIN
     "\r\n"
@@ -57,29 +57,30 @@
 #if defined(APSTUDIO_INVOKED) || defined(PROJECTEDITOR)
 #if defined(APSTUDIO_INVOKED)
-IDI_MAIN$(PROJECTEDITOR) ICON                    "icon1.ico"
+IDI_MAIN$(PROJECTEDITOR) ICON    DISCARDABLE     "icon1.ico"
 #else
-IDI_MAIN                ICON                    "icon1.ico"
+IDI_MAIN                ICON    DISCARDABLE     "icon1.ico"
 #endif
 #endif
-IDI_BASICPROGRAM        ICON                    "BasicProgram.ico"
-IDI_TEXTDOCUMENT        ICON                    "TextDocument.ico"
-IDI_FOLDER_CLOSE        ICON                    "folder_close.ico"
-IDI_FOLDER_OPEN         ICON                    "folder_open.ico"
-IDI_WINDOW              ICON                    "Window.ico"
-IDI_PROCEDURE           ICON                    "Procedure.ico"
-IDI_FILE_PJ             ICON                    "file_pj.ico"
-IDI_FILE_BAS            ICON                    "file_bas.ico"
-IDI_FILE_SBP            ICON                    "file_sbp.ico"
-IDI_FILE_ICON           ICON                    "file_icon.ico"
-IDI_FILE_BMP            ICON                    "file_bmp.ico"
-IDI_FILE_CURSOR         ICON                    "ico00001.ico"
+IDI_BASICPROGRAM        ICON    DISCARDABLE     "BasicProgram.ico"
+IDI_TEXTDOCUMENT        ICON    DISCARDABLE     "TextDocument.ico"
+IDI_FOLDER_CLOSE        ICON    DISCARDABLE     "folder_close.ico"
+IDI_FOLDER_OPEN         ICON    DISCARDABLE     "folder_open.ico"
+IDI_WINDOW              ICON    DISCARDABLE     "Window.ico"
+IDI_PROCEDURE           ICON    DISCARDABLE     "Procedure.ico"
+IDI_FILE_PJ             ICON    DISCARDABLE     "file_pj.ico"
+IDI_FILE_BAS            ICON    DISCARDABLE     "file_bas.ico"
+IDI_FILE_SBP            ICON    DISCARDABLE     "file_sbp.ico"
+IDI_FILE_ICON           ICON    DISCARDABLE     "file_icon.ico"
+IDI_FILE_BMP            ICON    DISCARDABLE     "file_bmp.ico"
+IDI_FILE_CURSOR         ICON    DISCARDABLE     "ico00001.ico"
 #if defined(APSTUDIO_INVOKED) || defined(THETEXT)
 #if defined(APSTUDIO_INVOKED)
-IDI_MAIN$(THETEXT)      ICON                    "main.ico"
+IDI_MAIN$(THETEXT)      ICON    DISCARDABLE     "main.ico"
 #else
-IDI_MAIN                ICON                    "main.ico"
+IDI_MAIN                ICON    DISCARDABLE     "main.ico"
 #endif
 #endif
 
+#ifndef _MAC
 /////////////////////////////////////////////////////////////////////////////
 //
@@ -88,6 +89,6 @@
 
 VS_VERSION_INFO VERSIONINFO
- FILEVERSION 5,0,6,0
- PRODUCTVERSION 5,0,6,0
+ FILEVERSION 5,0,0,5
+ PRODUCTVERSION 5,0,0,5
  FILEFLAGSMASK 0x17L
 #ifdef _DEBUG
@@ -104,12 +105,16 @@
         BLOCK "041104b0"
         BEGIN
-            VALUE "CompanyName", "activebasic.com"
-            VALUE "FileDescription", "ActiveBasic"
-            VALUE "FileVersion", "5, 0, 6, 0"
-            VALUE "InternalName", "abdev"
-            VALUE "LegalCopyright", "Copyright (C) 2008 activebasic.com"
-            VALUE "OriginalFilename", "abdev.exe"
-            VALUE "ProductName", "ActiveBasic"
-            VALUE "ProductVersion", "5, 0, 6, 0"
+            VALUE "Comments", "\0"
+            VALUE "CompanyName", "activebasic.com\0"
+            VALUE "FileDescription", "ActiveBasic\0"
+            VALUE "FileVersion", "5, 0, 0, 5\0"
+            VALUE "InternalName", "abdev\0"
+            VALUE "LegalCopyright", "Copyright (C) 2008 activebasic.com\0"
+            VALUE "LegalTrademarks", "\0"
+            VALUE "OriginalFilename", "abdev.exe\0"
+            VALUE "PrivateBuild", "\0"
+            VALUE "ProductName", "ActiveBasic\0"
+            VALUE "ProductVersion", "5, 0, 0, 5\0"
+            VALUE "SpecialBuild", "\0"
         END
     END
@@ -119,4 +124,6 @@
     END
 END
+
+#endif    // !_MAC
 
 #endif    // 日本語 resources