Index: trunk/ab5.0/abdev/abdev/SubOperation.cpp
===================================================================
--- trunk/ab5.0/abdev/abdev/SubOperation.cpp	(revision 655)
+++ trunk/ab5.0/abdev/abdev/SubOperation.cpp	(revision 681)
@@ -413,220 +413,4 @@
 	return ans;
 }
-BOOL IsManagementCommand(int ComNum){
-	switch(ComNum){
-		case -1:
-		case COM_ABSTRACT:
-		case COM_CLASS:
-		case COM_CONST:
-		case COM_DEBUG:
-		case COM_DECLARE:
-		case COM_DEF:
-		case COM_DIM:
-		case COM_DO:
-		case COM_END:
-		case COM_ENUM:
-		case COM_FOR:
-		case COM_FUNCTION:
-		case COM_GOSUB:
-		case COM_GOTO:
-		case COM_IF:
-		case COM_INHERITS:
-		case COM_INTERFACE:
-		case COM_LOOP:
-		case COM_NAMESPACE:
-		case COM_NEXT:
-		case COM_PRIVATE:
-		case COM_PROTECTED:
-		case COM_PUBLIC:
-		case COM_RETURN:
-		case COM_SELECT:
-		case COM_SUB:
-		case COM_TRY:
-		case COM_TYPE:
-		case COM_TYPEDEF:
-		case COM_VIRTUAL:
-		case COM_OVERRIDE:
-		case COM_WEND:
-		case COM_WHILE:
-		case COM_WITH:
-			return 1;
-		default:
-			break;
-	}
-	return 0;
-}
-int IsBasicReservedWord(char *str){
-	if(str[0]=='a'||str[0]=='A'){
-		if(lstrcmpi(str,"Abstract")==0) return COM_ABSTRACT;
-		if(lstrcmpi(str,"As")==0) return -1;
-	}
-	else if(str[0]=='b'||str[0]=='B'){
-		if(lstrcmpi(str,"Beep")==0) return COM_BEEP;
-		if(lstrcmp(str,"Boolean")==0) return -1;
-		if(lstrcmpi(str,"ByRef")==0) return -1;
-		if(lstrcmpi(str,"ByVal")==0) return -1;
-		if(lstrcmp(str,"Byte")==0) return -1;
-	}
-	else if(str[0]=='c'||str[0]=='C'){
-		if(lstrcmpi(str,"Catch")==0) return -1;
-		if(lstrcmpi(str,"Case")==0) return -1;
-		if(lstrcmp(str,"Char")==0) return -1;
-		if(lstrcmpi(str,"ChDir")==0) return COM_CHDIR;
-		if(lstrcmpi(str,"Circle")==0) return COM_CIRCLE;
-		if(lstrcmpi(str,"Class")==0) return COM_CLASS;
-		if(lstrcmpi(str,"Close")==0) return COM_CLOSE;
-		if(lstrcmpi(str,"Cls")==0) return COM_CLS;
-		if(lstrcmpi(str,"Color")==0) return COM_COLOR;
-		if(lstrcmpi(str,"Const")==0) return COM_CONST;
-		if(lstrcmpi(str,"Continue")==0) return -1;
-	}
-	else if(str[0]=='d'||str[0]=='D'){
-		if(lstrcmpi(str,"Debug")==0) return COM_DEBUG;
-		if(lstrcmpi(str,"Declare")==0) return COM_DECLARE;
-		if(lstrcmpi(str,"Def")==0) return COM_DEF;
-		if(lstrcmpi(str,"Delegate")==0) return -1;
-		if(lstrcmpi(str,"Delete")==0) return -1;
-		if(lstrcmpi(str,"DelWnd")==0) return COM_DELWND;
-		if(lstrcmpi(str,"Dim")==0) return COM_DIM;
-		if(lstrcmpi(str,"Do")==0) return COM_DO;
-		if(lstrcmp(str,"Double")==0) return -1;
-		if(lstrcmp(str,"DWord")==0) return -1;
-	}
-	else if(str[0]=='e'||str[0]=='E'){
-		if(lstrcmpi(str,"Else")==0) return -1;
-		if(lstrcmpi(str,"ElseIf")==0) return -1;
-		if(lstrcmpi(str,"End")==0) return COM_END;
-		if(lstrcmpi(str,"EndIf")==0) return -1;
-		if(lstrcmpi(str,"EndFunction")==0) return -1;
-		if(lstrcmpi(str,"EndSub")==0) return -1;
-		if(lstrcmpi(str,"EndType")==0) return -1;
-		if(lstrcmpi(str,"EndSelect")==0) return -1;
-		if(lstrcmpi(str,"EndWith")==0) return -1;
-		if(lstrcmpi(str,"Enum")==0) return COM_ENUM;
-		if(lstrcmpi(str,"Exit")==0) return -1;
-		if(lstrcmpi(str,"ExitDo")==0) return -1;
-		if(lstrcmpi(str,"ExitFor")==0) return -1;
-		if(lstrcmpi(str,"ExitFunction")==0) return -1;
-		if(lstrcmpi(str,"ExitSub")==0) return -1;
-		if(lstrcmpi(str,"ExitWhile")==0) return -1;
-	}
-	else if(str[0]=='f'||str[0]=='F'){
-		if(lstrcmp(str,"False")==0) return -1;
-		if(lstrcmpi(str,"Field")==0) return COM_FIELD;
-		if(lstrcmpi(str,"Finally")==0) return -1;
-		if(lstrcmpi(str,"For")==0) return COM_FOR;
-		if(lstrcmpi(str,"Foreach")==0) return -1;
-		if(lstrcmpi(str,"Function")==0) return COM_FUNCTION;
-	}
-	else if(str[0]=='g'||str[0]=='G'){
-		if(lstrcmpi(str,"Get")==0) return COM_GET;
-		if(lstrcmpi(str,"GoSub")==0) return COM_GOSUB;
-		if(lstrcmpi(str,"Goto")==0) return COM_GOTO;
-	}
-	else if(str[0]=='i'||str[0]=='I'){
-		if(lstrcmpi(str,"If")==0) return COM_IF;
-		if(lstrcmpi(str,"Imports")==0) return -1;
-		if(lstrcmpi(str,"Implements")==0) return -1;
-		if(lstrcmpi(str,"In")==0) return -1;
-		if(lstrcmpi(str,"Inherits")==0) return COM_INHERITS;
-		if(lstrcmpi(str,"Input")==0) return COM_INPUT;
-		if(lstrcmp(str,"Int64")==0) return -1;
-		if(lstrcmp(str,"Integer")==0) return -1;
-		if(lstrcmpi(str,"Interface")==0) return COM_INTERFACE;
-	}
-	else if(str[0]=='k'||str[0]=='K'){
-		if(lstrcmpi(str,"Kill")==0) return COM_KILL;
-	}
-	else if(str[0]=='l'||str[0]=='L'){
-		if(lstrcmpi(str,"Let")==0) return COM_LET;
-		if(lstrcmpi(str,"Line")==0) return COM_LINE;
-		if(lstrcmpi(str,"Locate")==0) return COM_LOCATE;
-		if(lstrcmp(str,"Long")==0) return -1;
-		if(lstrcmpi(str,"Loop")==0) return COM_LOOP;
-	}
-	else if(str[0]=='m'||str[0]=='M'){
-		if(lstrcmpi(str,"MkDir")==0) return COM_MKDIR;
-		if(lstrcmpi(str,"MsgBox")==0) return COM_MSGBOX;
-	}
-	else if(str[0]=='n'||str[0]=='N'){
-		if(lstrcmpi(str,"Namespace")==0) return COM_NAMESPACE;
-		if(lstrcmpi(str,"Next")==0) return COM_NEXT;
-		if(lstrcmpi(str,"New")==0) return -1;
-		if(lstrcmpi(str,"Nothing")==0) return -1;
-	}
-	else if(str[0]=='o'||str[0]=='O'){
-		if(lstrcmp(str,"Object")==0) return -1;
-		if(lstrcmpi(str,"Open")==0) return COM_OPEN;
-		if(lstrcmpi(str,"Operator")==0) return -1;
-		if(lstrcmpi(str,"Override")==0) return COM_OVERRIDE;
-	}
-	else if(str[0]=='p'||str[0]=='P'){
-		if(lstrcmpi(str,"Paint")==0) return COM_PAINT;
-		if(lstrcmpi(str,"Print")==0) return COM_PRINT;
-		if(lstrcmpi(str,"Private")==0) return COM_PRIVATE;
-		if(lstrcmpi(str,"Protected")==0) return COM_PROTECTED;
-		if(lstrcmpi(str,"PSet")==0) return COM_PSET;
-		if(lstrcmpi(str,"Put")==0) return COM_PUT;
-		if(lstrcmpi(str,"Public")==0) return COM_PUBLIC;
-	}
-	else if(str[0]=='q'||str[0]=='Q'){
-		if(lstrcmp(str,"QWord")==0) return -1;
-	}
-	else if(str[0]=='r'||str[0]=='R'){
-		if(lstrcmpi(str,"Randomize")==0) return COM_RANDOMIZE;
-		if(lstrcmpi(str,"Rem")==0) return COM_REM;
-		if(lstrcmpi(str,"Return")==0) return COM_RETURN;
-	}
-	else if(str[0]=='s'||str[0]=='S'){
-		if(lstrcmp(str,"SByte")==0) return -1;
-		if(lstrcmpi(str,"Select")==0) return COM_SELECT;
-		if(lstrcmpi(str,"SelectCase")==0) return COM_SELECT;
-		if(lstrcmp(str,"Single")==0) return -1;
-		if(lstrcmpi(str,"Sleep")==0) return COM_SLEEP;
-		if(lstrcmp(str,"Static")==0) return -1;
-		if(lstrcmpi(str,"Step")==0) return -1;
-		if(lstrcmp(str,"String")==0) return -1;
-		if(lstrcmpi(str,"Sub")==0) return COM_SUB;
-		if(lstrcmpi(str,"Super")==0) return -1;
-	}
-	else if(str[0]=='t'||str[0]=='T'){
-		if(lstrcmpi(str,"Then")==0) return -1;
-		if(lstrcmpi(str,"This")==0) return -1;
-		if(lstrcmpi(str,"Throw")==0) return -1;
-		if(lstrcmpi(str,"To")==0) return -1;
-		if(lstrcmp(str,"True")==0) return -1;
-		if(lstrcmp(str,"Try")==0) return COM_TRY;
-		if(lstrcmpi(str,"Type")==0) return COM_TYPE;
-		if(lstrcmpi(str,"TypeDef")==0) return COM_TYPEDEF;
-	}
-	else if(str[0]=='u'||str[0]=='U'){
-		if(lstrcmpi(str,"Until")==0) return -1;
-	}
-	else if(str[0]=='v'||str[0]=='V'){
-		if(lstrcmpi(str,"Virtual")==0) return COM_VIRTUAL;
-	}
-	else if(str[0]=='w'||str[0]=='W'){
-		if(lstrcmpi(str,"Wend")==0) return COM_WEND;
-		if(lstrcmpi(str,"While")==0) return COM_WHILE;
-		if(lstrcmpi(str,"Window")==0) return COM_WINDOW;
-		if(lstrcmpi(str,"With")==0) return COM_WITH;
-		if(lstrcmp(str,"Word")==0) return -1;
-		if(lstrcmpi(str,"Write")==0) return COM_WRITE;
-	}
-	else if(str[0]=='#'){
-		if(lstrcmpi(str,"#include")==0) return -1;
-		if(lstrcmpi(str,"#strict")==0) return -1;
-		if(lstrcmpi(str,"#console")==0) return -1;
-		if(lstrcmpi(str,"#prompt")==0) return -1;
-		if(lstrcmpi(str,"#N88BASIC")==0) return -1;
-		if(lstrcmpi(str,"#define")==0) return -1;
-		if(lstrcmpi(str,"#ifdef")==0) return -1;
-		if(lstrcmpi(str,"#ifndef")==0) return -1;
-		if(lstrcmpi(str,"#else")==0) return -1;
-		if(lstrcmpi(str,"#endif")==0) return -1;
-	}
-	return 0;
-}
-
 HBITMAP CreateGradationBitmap(SIZE *pSize,COLORREF color1,COLORREF color2){
 	//グラデーションビットマップを生成